{% extends 'base.html.twig' %}

{% block title %}SnowTricks{% endblock %}

{% block body %}

    <style>
        .dev-card-one-trick-background {
            height: 600px;
            width: 100%;
            background-image: url("{{ asset('asset/images/p6_index_image.jpg') }}");
            background-size: cover;
            background-repeat: no-repeat;
        }

        .one-trick-medias * {
            overflow: unset !important;
        }

        iframe {
            width: 200px !important;
            height: 200px !important;
        }

    </style>





    {% for label, messages in app.flashes %}
        {% for message in messages %}
            <div class="alert alert-{{ label }} temporary">{{ message }}</div>
        {% endfor %}
    {% endfor %}

    <div class="dev-card-one-trick-background"></div>


    <div class="dev-one-trick">
        {#        <img class="dev-one-trick-main-image" src="{{ asset('asset/images/p6_index_image.jpg') }}" alt="Card image cap"> #}
        <img class="dev-one-trick-main-image" src="{{ asset('uploads/' ~ trick.images[0]) }}" alt="Card image cap">

        {% if (trick.user.userIdentifier is same as app.user.email|default('test.test')) or ('ROLE_ADMIN' in app.user.roles|default('ROLE_USER'))%}
            <div class="dev-one-trick-icons">
                <a href="/modify/trick/{{ trick.slug }}"><img src="{{ asset('asset/icons/pen.svg') }}" alt=""
                                                              class="dev-card-icons"></a>
                <a href="/delete/trick/{{ trick.slug }}"><img src="{{ asset('asset/icons/trash.svg') }}" alt=""
                                                              class="dev-card-icons"></a>
            </div>
        {% endif %}


        <div class="dev-one-trick-name">
            <div class="dev-one-trick-name-style">{{ trick.name }}</div>

        </div>

        <div class="mediaSlider d-flex justify-content-between align-items-center px-2 responsive-desktop"
             id="mediaSlider">

        </div>

        <div class="responsive-display mt-3" >
            <div onclick="displayResponsiveMedia()" id="buttonDisplayResponsiveMedia" >
                <div class="d-flex align-items-center justify-content-center">
                    <div style="width: 150px; height: 50px; border: 1px solid black" class="d-flex align-items-center justify-content-center">Voir les médias</div>
                </div>
            </div>
            <div class="row" style="display: none" id="responsiveMedia">
                <div class="d-flex align-items-center justify-content-between text-center flex-wrap">
                    {% for image in trick.images %}
                        <div class="w-50 mt-3 mb-3">
                            <div>
                                <img src="{{ asset('uploads/' ~ image) }}" alt="" class="media-image">
                            </div>
                        </div>
                    {% endfor %}

                    {% for video in trickvideo %}
                        <div class="w-50 mt-3 mb-3">
                            <div>
                                {{ video | raw }}
                            </div>
                        </div>
                    {% endfor %}
                </div>

            </div>

            <div onclick="hideResponsiveMedia()" id="buttonHideResponsiveMedia" style="display: none">
                <div class="d-flex align-items-center justify-content-center">
                    <div style="width: 150px; height: 50px; border: 1px solid black" class="d-flex align-items-center justify-content-center">Cacher les médias</div>
                </div>
            </div>
        </div>

        <div class="mt-5 px-5 pe-5">
            {{ trick.description | nl2br }}
        </div>


        <div class="w-50 m-auto mt-5 row">
            {% for tag in trick.tags %}
                <div class="col-lg-3 col-md-6 col-sm-12 mt-4 mb-4">
                    <div class="dev-one-trick-tags">{{ tag.tagName }}</div>
                </div>
            {% endfor %}
        </div>

        <div class="w-75 m-auto mt-4 mb-4 border-bottom"></div>

        {% if user is not null %}
            <div class="col-8 m-auto">
                {{ form_start(comment_form, {'attr': {'class': 'd-flex'}}) }}
                {{ form_widget(comment_form.content, {'attr': {'class': 'form-control me-2'}}) }}
                {{ form_widget(comment_form.Submit, {'attr': {'class': 'btn btn-outline-success'}}) }}
                {{ form_end(comment_form) }}
            </div>

            <div class="w-75 m-auto mt-4 mb-4 border-bottom"></div>
        {% endif %}


        <div class="row col-sm-10 col-md-8 col-lg-6  m-auto mb-5">
            {% for comment in comments %}
                <div class="col-12 mt-4 d-flex justify-content-between">
                    <div style="width: 200px;" class="d-flex justify-content-center align-items-center flex-column">
                        <img src="{{ asset('uploads/' ~ comment.author.image.name) }}" alt="" class="comment-user-img">
                        <div>{{ comment.author.username }}</div>
                    </div>
                    <div class="comment-user-message d-flex justify-content-between">
                        {{ comment.content | nl2br }}
                        {% if user %}
                            {% if "ROLE_ADMIN" in user.roles %}
                                <a href="/user/delete/comment/{{ comment.id }}">X</a>

                            {% elseif comment.author.email == user.userIdentifier %}
                                <a href="/user/delete/comment/{{ comment.id }}">X</a>
                            {% endif %}
                        {% endif %}
                    </div>
                </div>
            {% endfor %}
            <div class="d-flex justify-content-center align-items-center">
                {% if maxPagesComments != 0 %}
                    {% for i in 1..maxPagesComments %}
                        {% if i == page %}
                            <a href="{{ path('app_one_trick', {'page': i, 'slug': trick.slug}) }}"
                               class="fs-2 mx-2" style="text-decoration: none; color: black">{{ i }}</a>
                        {% else %}
                            <a href="{{ path('app_one_trick', {'page': i, 'slug': trick.slug}) }}"
                               class="fs-5 mx-2" style="text-decoration: none; color: black">{{ i }}</a>
                        {% endif %}
                    {% endfor %}
                {% endif %}

            </div>
        </div>
    </div>

    <script>

        const url = window.location.href;
        const productName = url.match(/\/details\/(.*)/)[1];


        function displayTrickMedias() {
            var trickMedia = document.getElementById('mediaSlider');

            var xhr = new XMLHttpRequest();
            xhr.open('GET', '/get/tricks/' + productName + '/images');
            xhr.setRequestHeader('Content-Type', 'application/json');
            xhr.onload = function () {
                if (xhr.status === 200) {
                    var response = JSON.parse(xhr.responseText);
                    console.log(response);
                    var buttonPrevious = document.createElement('button');
                    buttonPrevious.setAttribute('class', 'btn btn-outline-success col-1 mt-4 media-button media-slider-button');
                    buttonPrevious.innerHTML = '<';

                    trickMedia.appendChild(buttonPrevious);
                    indexVideo = 0;
                    response.tricks.forEach(function (product) {

                        if (product.imageName) {
                            // console.log(product.imageName);
                            var div = document.createElement('div');
                            var img = document.createElement('img');
                            var imgTrash = document.createElement('img');
                            imgTrash.src = '{{ asset('asset/icons/trash.svg') }}';
                            imgTrash.setAttribute('class', 'dev-card-icons');
                            div.setAttribute('class', 'col-2 mt-4')
                            img.src = '{{ asset('uploads/') }}' + product.imageName;
                            img.style.width = '200px';
                            img.style.height = '200px';
                            img.objectFit = 'cover';
                            var a = document.createElement('a');
                            a.href = '/trick/detail/' + productName + '/delete/image/' + product.imageName;

                            if (response.user.trickAuthor === response.user.userEmail || response.user.userRole.includes('ROLE_ADMIN')) {
                                a.appendChild(imgTrash);
                            }

                            div.appendChild(img);
                            div.appendChild(a);
                            trickMedia.appendChild(div);
                        }

                        if (product.videoName) {
                            // console.log(product.videoName);
                            var div = document.createElement('div');
                            var imgTrash = document.createElement('img');
                            imgTrash.src = '{{ asset('asset/icons/trash.svg') }}';
                            imgTrash.setAttribute('class', 'dev-card-icons');
                            var a = document.createElement('a');
                            a.href = '/trick/detail/' + productName + '/delete/video/' + indexVideo;
                            indexVideo++;
                            if (response.user.trickAuthor === response.user.userEmail || response.user.userRole.includes('ROLE_ADMIN')) {
                                a.appendChild(imgTrash);
                            }
                            div.setAttribute('class', 'col-2 mt-4 p-0')
                            div.innerHTML = product.videoName;
                            div.appendChild(a);
                            trickMedia.appendChild(div);
                        }

                    });

                    var buttonNext = document.createElement('button');
                    buttonNext.setAttribute('class', 'btn btn-outline-success col-1 mt-4 media-button media-slider-button');
                    buttonNext.innerHTML = '>';

                    trickMedia.appendChild(buttonNext);

                    const container = document.getElementById("mediaSlider");
                    const divs = container.querySelectorAll("div");

                    for (var i = 0; i < divs.length; i++) {
                        divs[i].setAttribute('id', 'media-' + i);
                    }

                    mediaSlider();


                }
            };
            xhr.send();
        }

        function mediaSlider() {
            const mediasContainer = document.getElementById('mediaSlider');
            const medias = mediasContainer.querySelectorAll('div');
            const mediasButton = mediasContainer.querySelectorAll('button');
            const mediasToDisplay = 4;
            const mediasLength = medias.length;
            var firstMedia = 0;

            if (mediasLength < mediasToDisplay) {
                mediasContainer.removeChild(mediasButton[0]);
                mediasContainer.removeChild(mediasButton[1]);
            } else {
                for (let i = 0; i < mediasLength; i++) {
                    medias[i].style.display = 'none';
                }

                for (let i = firstMedia; i < mediasToDisplay; i++) {
                    medias[i].style.display = 'block';
                }

                const buttonPrevious = document.querySelector('.btn-outline-success:first-child');
                const buttonNext = document.querySelector('.btn-outline-success:last-child');

                buttonPrevious.addEventListener('click', function () {
                    if (firstMedia > 0) {
                        firstMedia--;
                        for (let i = 0; i < mediasLength; i++) {
                            medias[i].style.display = 'none';
                        }
                        for (let i = firstMedia; i < mediasToDisplay + firstMedia; i++) {
                            medias[i].style.display = 'block';
                        }
                    }
                });

                buttonNext.addEventListener('click', function () {
                    if (firstMedia < mediasLength - mediasToDisplay) {
                        firstMedia++;
                        for (let i = 0; i < mediasLength; i++) {
                            medias[i].style.display = 'none';
                        }
                        for (let i = firstMedia; i < mediasToDisplay + firstMedia; i++) {
                            medias[i].style.display = 'block';
                        }
                    }
                });
            }


        }


        displayTrickMedias()


        function displayResponsiveMedia() {
            var responsiveMedia = document.getElementById('responsiveMedia');
            responsiveMedia.style.display = 'block';
            var buttonResponsiveMedia = document.getElementById('buttonDisplayResponsiveMedia');
            buttonResponsiveMedia.style.display = 'none';
            var buttonHideResponsiveMedia = document.getElementById('buttonHideResponsiveMedia');
            buttonHideResponsiveMedia.style.display = 'block';
        }

        function hideResponsiveMedia() {
            var responsiveMedia = document.getElementById('responsiveMedia');
            responsiveMedia.style.display = 'none';
            var buttonResponsiveMedia = document.getElementById('buttonDisplayResponsiveMedia');
            buttonResponsiveMedia.style.display = 'block';
            var buttonHideResponsiveMedia = document.getElementById('buttonHideResponsiveMedia');
            buttonHideResponsiveMedia.style.display = 'none';
        }

    </script>
{% endblock %}
